#ifndef HAVE_LLIST
#define HAVE_LLIST 1
/*  #include "setup.h"	*/
#include <stddef.h>
struct llist {
  struct llist_element *head;
  struct llist_element *tail;
  int size;
};
struct llist_element {
  int  ID;
  int column;
  int count;
  char *ptr1;
  char *ptr2;
  struct llist *list1;
  struct llist *list2;
  struct llist_element *prev;
  struct llist_element *next;
};

typedef struct llist_element * LLISTELEM;
typedef struct llist * LLIST;

void llist_init(struct llist *);
struct llist *llist_alloc();
struct llist_element * llist_insert_next(struct llist *,
			struct llist_element *e, char *, char *);
struct llist_element * llist_insert_prev(struct llist *,
			struct llist_element *e, char *, char *);
struct llist_element * llist_remove(struct llist *,
			struct llist_element *);
void llist_destroy(struct llist *);
char * memcpyx (char *);
char * memrepx (char * p, char * n);
struct llist * ListLoad(char * FileIn);
int ListDump(struct llist *, char * FileIn, char * FileOut);
char * GetLine (struct llist * list, int id);
struct llist * list_read (char * FileName);
#endif

